<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2013 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";

function update_film($database, $user_id, $film_id, $film_type_id, $film_manufacturer_id,
                     $film_model, $film_iso, $film_format, $film_access_rights) {
  $result = TRUE;

  pg_query($database, "begin");

  if ($film_type_id=='custom') {
    /* film type has changed */
    $number_of_filmes_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from film where type=(select type from film where identifier='$film_id')"));
    if ($number_of_filmes_of_same_type[0] == 1) {
      /* there was only one film of this kind, so we have to remove it */
      $film_type_to_remove = pg_fetch_row(pg_query($database, "select type from film where identifier='$film_id'"));
    } else {
      $film_type_to_remove = FALSE;
    }
    /* create new type */
    $new_film_type_id = pg_fetch_row(pg_query($database, "select nextval('film_type_id_sequence')"));
    $film_type_id = $new_film_type_id[0];
    $result = pg_query($database, "insert into film_type (identifier, manufacturer, model, iso, format, last_modified_date, last_modifying_users)
                                   values ($film_type_id, $film_manufacturer_id, '$film_model', '$film_iso', '$film_format', now(), '$user_id')");
  }

  /* add film */
  if ($result) {
    $result = pg_query($database, "update film set type=$film_type_id, access_rights='$film_access_rights' where identifier='$film_id'");
  }

  /* remove old type */
  if ($result && $film_type_to_remove) {
    $result = pg_query($database, "delete from film_type where identifier='$film_type_to_remove[0]'");
  } 
  
  if ($result) {
    pg_query($database, "commit"); 
  } else {
    site_push_error($strings['errors_db_insert_failed']);
    pg_query($database, "rollback");
  }
}

$database = site_prolog(PO_USER_TYPE_USER);

$film_id = pg_escape_string($database, $_REQUEST['item_id']);

/* Ensure the user owns it !*/
if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
  $result = pg_fetch_row(pg_query($database, "select count(identifier) from film where identifier=$film_id and users=$po_user[id]"));
  if ($result[0] == 0) {
    site_referer_error('not_owner');
    site_epilog($database);
    exit();  
  }
 }

update_film($database, $po_user['id'], 
	    $film_id, 
	    pg_escape_string($database, $_REQUEST['film_type_id']), 
	    pg_escape_string($database, $_REQUEST['film_manufacturer_id']),
            pg_escape_string($database, $_REQUEST['film_model']), 
	    pg_escape_string($database, $_REQUEST['film_iso']), 
	    pg_escape_string($database, $_REQUEST['film_format_id']), 
	    pg_escape_string($database, $_REQUEST['film_access_rights']));

site_epilog($database);
header("Location: my.profile.php?selector=".$profile_data['film']['idx']);
?>
