--  Copyright (c) 2009 Solomon Peachy (pizza@shaftnet.org)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.37.B to 2.37.C patch 
----------------------------------------------------------

-- convert the 'hide original' column from a char to a boolean

ALTER TABLE photo ADD COLUMN hide_original_b boolean;
UPDATE photo set hide_original_b = 't' where hide_original = 't';
UPDATE photo set hide_original_b = 'f' where hide_original = 'f';
ALTER TABLE photo DROP COLUMN hide_original;
ALTER TABLE photo RENAME COLUMN hide_original_b TO hide_original;
ALTER TABLE photo ALTER COLUMN hide_original SET NOT NULL;

-- convert the 'category' column from a varchar(3) to a text;

ALTER TABLE photo ADD COLUMN category_b text;
UPDATE photo set category_b = category;
ALTER TABLE photo DROP COLUMN category;
ALTER TABLE photo RENAME COLUMN category_b TO category;

-- convert the 'master' column from a char to a boolean;

ALTER TABLE photo_version ADD COLUMN master_b boolean;
UPDATE photo_version set master_b = 't' where master = 't';
UPDATE photo_version set master_b = 'f' where master = 'f';
ALTER TABLE photo_version DROP COLUMN master;
ALTER TABLE photo_version RENAME COLUMN master_b TO master;
ALTER TABLE photo_version ALTER COLUMN master SET NOT NULL;

-- convert the 'original_image_name' from a varchar(500) to a text;

ALTER TABLE photo_version ADD COLUMN original_image_name_b text;
UPDATE photo_version set original_image_name_b = original_image_name;
ALTER TABLE photo_version DROP COLUMN original_image_name;
ALTER TABLE photo_version RENAME COLUMN original_image_name_b TO original_image_name;
ALTER TABLE photo_version ALTER COLUMN original_image_name SET NOT NULL;

-- Drop the print_id sequence
DROP SEQUENCE print_id_sequence;

-- version update 
update version set identifier=3, description='2.37 Development release', 
 major=2, minor=37, variation='C';
